/*  H8/300H newlib routine (need for Cygwin's gcc) */
#include <sys/stat.h>
#include <sys/types.h>
#include <errno.h>
#include "sci.h"


int _open(const char *buf, int flags, int mode)
{
   errno = EIO;
   return -1;
}


int _close(int fd)
{
   return 0;
}


int _read(int fd, char *buf, int len)
{
   char c;
   int i;

   for (i = 0; i < len; i++) {
      c = getc_SCI();
      putc_SCI(c);
      *buf++ = c;
      if (c == '\n') {
         i++;
         break;
      }
   }

   return i;
}


int _write(int fd, char *buf, int len)
{
   int i;

   for (i = 0; i < len; i++) {
      putc_SCI(*(buf++));
   }

   return len;
}


int _lseek(int fd, off_t offset, int whence)
{
   errno = ESPIPE;
   return (off_t) -1;
}


void _exit() __attribute__ ((noreturn));
void _exit(int status)
{
#ifdef ON_ROM_MONITOR
   asm("jmp	@@0x08:8");      /* Return ROM Monitor */
#else
   while (1);
#endif
}

extern char end;
static char *heap_ptr = &end;

char *_sbrk(int nbytes)
{
	char *base;

	base = heap_ptr;
	heap_ptr += nbytes;
	return(base);
}

int isatty(int desc)
{
    return 0;
}

int _fstat(int filedes, struct stat *buf)
{
    return -1;
}

