; h8/300 and h8/300h start up file (for ROM)

; Internal Control Register
#define ABWCR 0xFFFFEC:8
#define ASTCR 0xFFFFED:8
#define WCR   0xFFFFEE:8
#define WCER  0xFFFFEF:8
#define P1DDR 0xFFFFC0:8
#define P2DDR 0xFFFFC1:8
#define P5DDR 0xFFFFC8:8
#define P8DDR 0xFFFFCD:8

	.h8300h
;----------------------
; Start up routine
;----------------------
	.section .text
	.global	_start
_start:
	mov.l	#_stack,sp

; Board initialize
	mov.b	#0xff, r0l
	mov.b	r0l, @ABWCR		; CS1 bus width 8bits
	mov.b	#0xff, r0l
	mov.b	r0l, @ASTCR		; CS1 3cycles access
	mov.b	#0xf0, r0l		; Prigramable Wait Mode
	mov.b	r0l, @WCR		; Wait State 0
	mov.b	#0xff, r0l
	mov.b	r0l, @WCER		; WSC Enable
	mov.b	#0xff, r0l
	mov.b	r0l, @P1DDR		; P1 is address ports(A00-A07)
	mov.b	r0l, @P2DDR		; P2 is address ports(A08-A15)
	mov.b	r0l, @P5DDR		; P5 is address ports(A16-A19)
	mov.b	#0x08, r0l
	mov.b	r0l, @P8DDR		; P8-3 CS1 output enable

; copy DATA from ROM
	mov.l	#___dtors_end,er0
	mov.l	#_edata,er1
	mov.l	#___data,er2
.loop0:	mov.w	@er0,r3
	mov.w	r3,@er2
	adds	#2,er0
	adds	#2,er2
	cmp.l	er1,er2
	blo	.loop0

; clear BSS
	mov.l	#_edata,er0
	mov.l	#_end,er1
	mov.w	#0,r2		; not sure about alignment requirements
.loop:	mov.w	r2,@er0		; playing it safe for now
	adds	#2,er0
	cmp.l	er1,er0
	blo	.loop
	jsr	@___main
	jsr	@_main
	jsr	@_exit

	.section .stack
_stack:	.long 	1
